<?php
/*
    ---------------------------------------------------------------------------   
     awsCore.php 
    ---------------------------------------------------------------------------
     Core functions and utilities for Applications.
    ---------------------------------------------------------------------------
     Copyright 2013, AppGeo Solutions Ltd
     Godwin Badu-Marfo, started 31 January 2013
    --------------------------------------------------------------------------- 
*/

include_once('lookup.inc.php');
include_once('awsDB.inc.php');


class awsCore extends awsDB
{
	private static $frameworkurl = '../library/framework/';
	protected $content;
	
	
	public static function redMessage($message)
	/*
  	------------------------------------------------------------------------
	 Display a message in red on it's own line, uses an in-line style, no CSS requirements.
	 * @param string $message The message to display.
	------------------------------------------------------------------------
  	*/
	{
		print "<p><font color=red>$message</font></p>\n";
	}
	
	
	public static function successMessage($message)
	/*
  	------------------------------------------------------------------------
	 Display a message in red on it's own line, uses an in-line style, no CSS requirements.
	 * @param string $message The message to display.
	------------------------------------------------------------------------
  	*/
	{
		echo $message;
	}
	
	
	public static function errorMessage($message)
	/*
  	------------------------------------------------------------------------
	 Display an error message.
	 * @param string $message The message to display.
	------------------------------------------------------------------------
  	*/
	{
		print 'Error'.$message;
		die();
	}
	
	
	public static function getFormHeader($navTitle, $formTitle, $main=false, $search = true, $url ='www')
	/*
  	------------------------------------------------------------------------
	 Display a form header design
	 * @param string $title The message to display.
	------------------------------------------------------------------------
  	*/
	{        
		//print '<div class="navbar">'."\n";
		//print '<div class="navbar-inner">'."\n";
		//print '<a class="brand" href="#">'.$navTitle.'</a>'."\n";
		//print '</div>'."\n";
		//print '</div>'."\n";
		print '<hr  style="margin:5px 0"/>'."\n";
		//print '<legend style="line-height:20px; margin-bottom:0px">'."\n";
		if ($search === true)
		{
			print '<span style="float:left">Search <select style="margin-bottom:0px"></select></span>';
		}
		else
		{
			print '<label id="formTitle" style="float:left">'.$formTitle.' </label>';
		}
		print '<div data-toggle="buttons-radio" style="float:right; margin-bottom:5px">'."\n";
		//print '<select> </select>';
		if ($main == true)
		{
			//print '<button class="btn btn-primary" id="btnAddNew" name="btnAddNew"><i class="icon-plus-sign"></i>&nbsp;<b>Add New</b></button>'."\t"."\n";
			print '<a href="'.$url.'"  class="btn btn-primary"><b>Add New</b></a>';
		}
		else
		{
			print '<button class="btn btn-success" id="btnSave" name="btnSave"><i class="icon-hdd"></i>&nbsp;<b>Save</b></button>'."\t"."\n";
		}
		print '</div>'."\n";
		//print '</legend>'."\n";
		print '<div id="clearBoth946276" class="clearBoth">'."\n";
		print '<hr style="margin:5px 0;"/>'."\n";
		print '</div>'."\n";
		print '<div id="message" class="flexibleDiv" style="margin-top:5px;">'."\n";
		print '</div>'."\n";
	}
	
	
	public static function startHtmlPage($title)
  	/*
  	------------------------------------------------------------------------
	 Display html start information.
	 * @param string $title The message to display as page title
	------------------------------------------------------------------------
  	*/
  	{
		print("<!DOCTYPE html>\n");
		print("<html>\n");
		print("<head>\n");
		print("<meta charset=\"utf-8\">\n"); 
		print("<title>$title</title>\n");
		self::addStandardLinks('blue');
		//$this->addDefaultCSS();
		print("</head>\n");
		print("<body>\n");
        self::addOffCanvasMenu();
		self::addPageHeader('Deltaworks');
  	}
	
    
    static function addOffCanvasMenu()
    {
      /*print '
      <div class="navmenu navmenu-default navmenu-fixed-left">
      <a class="navmenu-brand" href="#">Project name</a>
      <ul class="nav navmenu-nav">
        <li><a href="../navmenu/">Slide in</a></li>
        <li><a href="../navmenu-push/">Push</a></li>
        <li class="active"><a href="./">Reveal</a></li>
        <li><a href="../navbar-offcanvas/">Off canvas navbar</a></li>
      </ul>
      <ul class="nav navmenu-nav">
        <li><a href="#">Link</a></li>
        <li><a href="#">Link</a></li>
        <li><a href="#">Link</a></li>
        <li class="dropdown">
          <a href="#" class="dropdown-toggle" data-toggle="dropdown">Dropdown <b class="caret"></b></a>
          <ul class="dropdown-menu navmenu-nav">
            <li><a href="#">Action</a></li>
            <li><a href="#">Another action</a></li>
            <li><a href="#">Something else here</a></li>
            <li class="divider"></li>
            <li class="dropdown-header">Nav header</li>
            <li><a href="#">Separated link</a></li>
            <li><a href="#">One more separated link</a></li>
          </ul>
        </li>
      </ul>
      </div>'."\n";  */ 
    }
    
    static function addOffCanvasButton()
    /*
	---------------------------------------------------------------------------
	 Add Off Canvas Button Menu
	---------------------------------------------------------------------------
	*/    
    {
    /*print '
     <div class="navbar navbar-default navbar-fixed-top">
        <button type="button" class="navbar-toggle" data-toggle="offcanvas" data-recalc="false" 
            data-target=".navmenu" data-canvas=".canvas">
            <span class="icon-bar"></span>
            <span class="icon-bar"></span>
            <span class="icon-bar"></span>
        </button>
      </div>'."\n";   */
    }
    
	
	static function addPageHeader($title)
	/*
	---------------------------------------------------------------------------
	 Adds Header to the page.
	---------------------------------------------------------------------------
	*/
	{
        //print '<div class="canvas">';
        //self::addOffCanvasButton();
        //print '<div class="container">'."\n";
		//print '<div id="pageHeader">'."\n";
		//print '<span id="appTitle">| '.$title.'</span>'."\n";
		//print '</div>'."\n";
        
        
        print '<nav class="navbar navbar-inverse navbar-fixed-top" style="background-color:#485566; height:30px; width:100%" role="navigation">'."\n";
        print '<div class="container-fluid no-padding">'."\n";
        print '<div class="navbar-header">'."\n";
        print '<div class="header-title">'."\n";
        print '<p class="glyphicon glyphicon-tree-conifer">'.$title.'</p>'."\n";
        print '</div>'."\n";
        print '</div>'."\n";
        print '<ul class="nav navbar-nav navbar-right" style="margin-right:10px">'."\n";
        print '<li><a class="search-modal" title="Search" data-toggle="modal" data-target="#search-modal">
        <span class="glyphicon glyphicon-search"></span>'."\n";         
        print '<span>Search</span></a></li>'."\n";
        print '<li><a class="about-modal" title="About" data-toggle="modal" data-target="#about-modal">
        <i class="glyphicon glyphicon-question-sign"></i>'."\n";                   
        print '<span>About</span></a></li>'."\n";
        print '</ul>'."\n";
        print '</div><!-- /.container-fluid -->'."\n";
        print '</nav>'."\n";
        print '<div class="clearfix"></div>'."\n";
        print '<div class="canvas">'."\n";
        print '<div class="container">'."\n";
		/*print '<div id="contentArea" class="container-fluid">'."\n";
		print '<div class="row-fluid">'."\n";*/
		/*print '<div id="sideBar" class="span2">'."\n";
		include_once ('menu.inc.php');
		print '</div>'."\n";*/
		//print '<div id="BodyContent" class="container" style="margin-top:10px">'."\n";
	}
	
    
    
    static function pageFooter()
    {
        print '<div class="clearfix"></div>'."\n";
        print '<nav class="navbar navbar-default navbar-fixed-bottom" style="background-color:#485566; height:30px; width:100%" role="navigation">'."\n";
        print '<div class="container">'."\n";
        print '<p class="navbar-text">Signed in as Mark Otto</p>'."\n";
        print '</div>'."\n";
        print '</nav>'."\n";
    }
    
	
	public static function closeHtmlPage($pageJS = "page.js")
	/*
	  ------------------------------------------------------------------------
	   Close an html page
	  ------------------------------------------------------------------------
	*/
	{
	/*  print '</div>'."\n";*/
	    print "\n";
	    print '</div>'."\n";
        print '</div>'."\n";
        self::pageFooter();
        self::addJSLinks("$pageJS");
	    print("</body>\n");
	    print("</html>");
	}
		
	
	public static function addStandardLinks($theme = "blue")
	/*
  	------------------------------------------------------------------------
	 addStandardLinks()
  	------------------------------------------------------------------------
	 adds the standard links.
	------------------------------------------------------------------------
    */
	{
		print("<link rel=\"stylesheet\" href=\"../library/public/css/style.css\">\n");
		print("<link rel=\"stylesheet\" href=\"../library/public/css/smoothness/jquery-ui-1.10.1.custom.css\">\n");
		/*print("<link rel=\"stylesheet\" href=\"../library/framework/js/codeCanvas/css/runtime.css\">\n");*/
		print("<link rel=\"stylesheet\" href=\"../library/framework/js/codeCanvas/css/usertools_run.css\">\n");
		/*print("<script type=\"text/javascript\" charset=\"utf-8\" src=\"".self::$frameworkurl."js/codeCanvas/js/canvas_libs.js\"></script>\n");	
		print("<script type=\"text/javascript\" charset=\"utf-8\" src=\"".self::$frameworkurl."js/codeCanvas/js/usertools_run.js\"></script>\n");*/	
		
		/*print("<link rel=\"stylesheet\" href=\"../library/framework/js/bootstrap/css/bootstrap-responsive.css\">\n");*/
/*		print("<script type=\"text/javascript\" src=\"../library/public/js/jquery-2.0.2.min.js\"></script>\n");
		print("<script type=\"text/javascript\" src=\"../library/public/js/jquery-ui-1.10.1.custom.js\"></script>\n");
		print("<script type=\"text/javascript\" src=\"../library/clientside/".$pagejs."\"></script>\n");*/
		
		print "<!-- Bootstrap: required -->\n";
		print("<link rel=\"stylesheet\" href=\"../library/js/bootstrap/css/bootstrap.css\">\n");
        print("<link rel=\"stylesheet\" href=\"../library/js/bootstrap/css/datatable-bootstrap.min.css\">\n");
        print("<link rel=\"stylesheet\" href=\"../library/css/style.css\">\n");
        print("<link rel=\"stylesheet\" href=\"../library/css/navmenu-reveal.css\">\n");
//		print("<link rel=\"stylesheet\" href=\"../library/framework/js/bootstrap/js/bootstrap.js\">\n");
        
        
	/*	print("<script type=\"text/javascript\" charset=\"utf-8\" src=\"".self::$frameworkurl."js/bootstrap/js/bootstrap.js\"></script>\n\n");*/
        
        print "<!-- ArcGIS  required -->\n";
        print "<link rel=\"stylesheet\" href=\"http://js.arcgis.com/3.10/js/esri/css/esri.css\">\n";

		print "<!-- Generic page styles -->\n";
        print("<link rel=\"stylesheet\" href=\"../library/js/JFileUpload/css/style.css\">\n");
        print "<!-- blueimp Gallery styles -->\n";
        print("<link rel=\"stylesheet\" href=\"http://blueimp.github.io/Gallery/css/blueimp-gallery.min.css\">\n");
        print "<!-- CSS to style the file input field as button and adjust the Bootstrap progress bars -->\n";
        print("<link rel=\"stylesheet\" href=\"../library/js/JFileUpload/css/jquery.fileupload.css\">\n");
        print("<link rel=\"stylesheet\" href=\"../library/js/JFileUpload/css/jquery.fileupload-ui.css\">\n");
        print "<!-- CSS adjustments for browsers with JavaScript disabled -->\n";
        print("<noscript><link rel=\"stylesheet\" href=\"../library/js/JFileUpload/css/jquery.fileupload-noscript.css\"></noscript>\n");
        print("<noscript><link rel=\"stylesheet\" href=\"../library/js/JFileUpload/css/jquery.fileupload-ui-noscript.css\"></noscript>\n");

		/*print "<!-- Tablesorter: required -->\n";
		print("<link rel=\"stylesheet\" href=\"".self::$frameworkurl."js/tablesorter/css/theme.".$theme.".css\">\n");
		print("<script type=\"text/javascript\" charset=\"utf-8\" src=\"".self::$frameworkurl."js/tablesorter/js/jquery.tablesorter.js\"></script>\n");
		print("<script type=\"text/javascript\" charset=\"utf-8\" src=\"".self::$frameworkurl."js/tablesorter/js/jquery.tablesorter.widgets.js\"></script>\n");		*/
//		print("<script type=\"text/javascript\" src=\"".self::$frameworkurl."js/awsJS.js\"></script>\n");	
	}
    
    
    public static function addJSLinks($pageJS = "page.js")
    /*
  	------------------------------------------------------------------------
	 addJSLinks()
  	------------------------------------------------------------------------
	 adds the standard JS links.
	------------------------------------------------------------------------
    */    
    {
        print "<!-- Javascript required -->\n";
        print("<script type=\"text/javascript\" charset=\"utf-8\" src=\"".self::$frameworkurl."js/codeCanvas/js/canvas_libs.js\"></script>\n");	
		print("<script type=\"text/javascript\" charset=\"utf-8\" src=\"".self::$frameworkurl."js/codeCanvas/js/usertools_run.js\"></script>\n");
        
        
        print "<!-- JQuery: required -->\n";
        print("<script type=\"text/javascript\" src=\"../library/public/js/jquery-2.0.2.min.js\"></script>\n");
		print("<script type=\"text/javascript\" src=\"../library/public/js/jquery-ui-1.10.1.custom.js\"></script>\n");
		print("<script type=\"text/javascript\" src=\"../library/clientside/".$pageJS."\"></script>\n");
        
        print "<!-- Bootstrap: required -->\n";
        print("<script type=\"text/javascript\" charset=\"utf-8\" src=\"../library/js/bootstrap/js/bootstrap.js\"></script>\n\n");
        print("<script type=\"text/javascript\" charset=\"utf-8\" src=\"../library/js/bootstrap/js/datatable.min.js\"></script>\n\n");
        
        print "<!-- lib JS Core: required -->\n";
        print("<script type=\"text/javascript\" src=\"".self::$frameworkurl."js/awsJS.js\"></script>\n");
        
        print "<!-- Arcgis JS: required -->\n";
        print "<script src=\"http://js.arcgis.com/3.10/\"></script>\n";
        
        print "<!-- Tiny MCE: required -->\n";
        print("<script type=\"text/javascript\" src=\"../library/js/tinymce/js/tinymce/tinymce.min.js\"></script>\n");
        print("<script type=\"text/javascript\" src=\"../library/js/tinymce/js/tinymce/jquery.tinymce.min.js\"></script>\n");
    }
  
	
	
	public static function getQuery($action)
	/*
  	------------------------------------------------------------------------
	 getQuery()
  	------------------------------------------------------------------------
	 Retrieves the sql statement
	------------------------------------------------------------------------
    */
	{
		if (isset($action) && strlen($action) > 0)
		{
			$sRet = '';
			$sRet = GetScript($action);
			return $sRet;
		}
	}
	
	
	public static function bindCombo($control, $query, $value=0)
	/*
	---------------------------------------------------------------------------
	 bindCombo()
	---------------------------------------------------------------------------
	 Populates combo control with datasource.
	 @param string Name of combo box control;
	 @param string SQL script to execute and returns results.
	---------------------------------------------------------------------------   
	*/ 
	{
        
		if (!isset($query))
		{
			die('Invalid sql statement parsed!');
		}
		
        // instantiate DB Connection
		$conn = parent::Connect();
		
        if ($conn && $query)
        {
            //$recordset = parent::fetchRecordset($query);   
        }
		//$recordset = sqlsrv_query($conn, $query);
		$recordset = mysqli_query(self::$handle, $query);
		
		if ($value != 0 )
		{	
			echo "<select name = \"".$control."\"  id=\"".$control."\"  class=\"form-control\" style=\"width:90%\">";
			
			//while ($row = sqlsrv_fetch_array($recordset, SQLSRV_FETCH_NUMERIC))
			while ($row = mysqli_fetch_array($recordset, MYSQL_NUM))
            {
				if ($row[0] == $value)
				{
					echo "<option value =\"{$row[0]}\" selected=\"selected\">{$row[1]}</option>";
				}
				echo "<option value =\"{$row[0]}\">{$row[1]}</option>";
			}
			echo "</select>";
		}
		else
		{
			//Populate the combo box on load
			echo "<select name = \"".$control."\"  id=\"".$control."\"  class=\"form-control\" style=\"width:90%\">";
			
			echo "<option selected=\"selected\" value=\"0\"> -- None -- </option>";
			
			//while ($row = sqlsrv_fetch_array($recordset, SQLSRV_FETCH_NUMERIC))
            while ($row = mysqli_fetch_array($recordset, MYSQL_NUM))
			{
				echo "<option value =\"{$row[0]}\">{$row[1]}</option>";
			}
			echo "</select>";
		}
	}
	
	
	public static function formMenuControl()
	/*
	  ------------------------------------------------------------------------
	   Menu buttons on the form.
	  ------------------------------------------------------------------------
	*/
	{
		print '<button id="btnSave" name="btnSave" value="insert">Save</button>'."\n";
		print '<button id="btnEdit" name="btnEdit" value="update">Edit</button>'."\n";
		print '<button id="btnDelete" name="btnDelete" value="delete">Delete</button>'."\n";
		print '<button id="btnClose" name="btnClose" value="close">Close</button>'."\n";
		print '<br>'."\n";
		print '<br>'."\n";
	}
	
	
	
	function escape($txt, $keepWhiteSpace=false)
	/*
	  ------------------------------------------------------------------------
	   Masks the text displayed on the HTML page
	   Replaces critical characters with entities and
	   deletes all characters less than chr(32) depending on white space option
	  ------------------------------------------------------------------------
	   @param string $txt Text
	   @param boolean $keepWhiteSpace Leave white space as is
	  ------------------------------------------------------------------------
	*/  
	{
		if ($keepWhiteSpace) 
		{
			$txt = preg_replace('/[\\x00-\\x08\\x0b-\\x1f]/', '', $txt);
			return filter_var($txt, FILTER_SANITIZE_SPECIAL_CHARS);
		} 
		else 
		{
			$txt = preg_replace('/\s+/', ' ', $txt);
			return filter_var($txt, FILTER_SANITIZE_SPECIAL_CHARS,
			FILTER_FLAG_STRIP_LOW);
		}
	}
	
	
	
/**
 * Translate a result array into a HTML table
 *
 * @author      Aidan Lister <aidan@php.net>
 * @version     1.3.2
 * @link        http://aidanlister.com/2004/04/converting-arrays-to-human-readable-tables/
 * @param       array  $array      The result (numericaly keyed, associative inner) array.
 * @param       bool   $recursive  Recursively generate tables for multi-dimensional arrays
 * @param       string $null       String to output for blank cells
 */
public static function array2table($array, $recursive = false, $url='www', $null = '&nbsp;')
{
    // Sanity check
    if (empty($array) || !is_array($array)) {
        return false;
    }
 
    if (!isset($array[0]) || !is_array($array[0])) {
        $array = array($array);
    }
 
    // Start the table
    $table = "<table class=\"table \">\n";
	
 
    // The header
    $table .= "\t<thead><tr>";
    // Take the keys from the first row as the headings
    foreach (array_keys($array[0]) as $heading) {
        $table .= '<th>' . $heading . '</th>';
    }
    $table .= "</tr></thead>\n";
 	
	
    // The body
    foreach ($array as $row) {
        $table .= "\t<tbody><tr>" ;
        foreach ($row as $cell) {
            $table .= '<td>';
 
            // Cast objects
            if (is_object($cell)) { $cell = (array) $cell; }
             
            if ($recursive === true && is_array($cell) && !empty($cell)) {
                // Recursive mode
                $table .= "\n" . self::array2table($cell, true, true) . "\n";
            } else {
                $table .= (strlen($cell) > 0) ?
                    htmlspecialchars_decode((string) $cell) :
                    $null;
            }
 
            $table .= '</td>';
        }
 
        $table .= "</tr><tbody>\n";
    }
 
    $table .= '</table>';
    echo $table;
}
    


public static function camelCase($subject, $delimiters=' _-', $lcfirst=true)
  {
    if ( ! is_string($subject))
    {
      throw new Exception("Subject must be of type string");
    }
    $subject = preg_replace('/[\s]+/', ' ', $subject);
    
    $subject = preg_split("/[$delimiters]/", $subject, -1, PREG_SPLIT_NO_EMPTY);
    
    foreach ($subject as $key => &$word)
    {
      $word = preg_replace('/[[:punct:]]/', '', $word);
      
      if (preg_match('/[A-Z]+$/', $word)) $word = ucfirst($word);
      
      else $word = ucfirst( strtolower($word) );
    }
    $subject = implode('', $subject);
    
    if ($lcfirst)
    {
      return function_exists('lcfirst') ? lcfirst($subject)
      :
      strtolower($subject[0]).substr($subject,1);
    }
    return $subject;
  }

}
?>