<?php
/*
    ---------------------------------------------------------------------------   
     awsDataTable.php 
    ---------------------------------------------------------------------------
     setup functions for datatables.
    ---------------------------------------------------------------------------
     Copyright 2013, AppGeo Solutions Ltd
     Godwin Badu-Marfo, started 22 February 2013
    --------------------------------------------------------------------------- 
*/
	
	// ----- library references
	include_once('awsDB.inc.php');

class awsGrid
{
    /* Indexed column (used for fast and accurate table cardinality) */
    public static $sIndexColumn;
       
    /* DB table to use */
    public static $sTable;
     
     
    /*
    * Columns
    * If you don't want all of the columns displayed you need to hardcode $aColumns array with your elements.
    * If not this will grab all the columns associated with $sTable
    */
    public static $aColumns = array();
 
 
    /* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
     * If you just want to use the basic configuration for DataTables with PHP server-side, there is
     * no need to edit below this line
     */
     
    /* 
     * ODBC connection
     */
    private static $params = array();
    private static $options =  array( "Scrollable" => SQLSRV_CURSOR_KEYSET );
	private static $conn;
	
      
	public static function generateTable()
	{
		// ---- set connection to server
		$conn = awsDB::Connect();	
		
		/*Hack the variables*/
		$sTable = self::$sTable;
		$sIndexColumn = self::$sIndexColumn;
		$aColumns = self::$aColumns;
		$params = self::$params;
		$options = self::$options;
		//$sEcho = intval($_GET['sEcho']);
		$sEcho = 1;
		
		/* Ordering */
		$sOrder = "";
		if ( isset( $_GET['iSortCol_0'] ) ) {
			$sOrder = "ORDER BY  ";
			for ( $i=0 ; $i<intval( $_GET['iSortingCols'] ) ; $i++ ) {
				if ( $_GET[ 'bSortable_'.intval($_GET['iSortCol_'.$i]) ] == "true" ) {
					$sOrder .= $aColumns[ intval( $_GET['iSortCol_'.$i] ) ]."
						".addslashes( $_GET['sSortDir_'.$i] ) .", ";
				}
			}
			$sOrder = substr_replace( $sOrder, "", -2 );
			if ( $sOrder == "ORDER BY" ) {
				$sOrder = "";
			}
		}
		  
		/* Filtering */
		$sWhere = "";
		if ( isset($_GET['sSearch']) && $_GET['sSearch'] != "" ) {
			$sWhere = "WHERE (";
			for ( $i=0 ; $i<count($aColumns) ; $i++ ) {
				$sWhere .= $aColumns[$i]." LIKE '%".addslashes( $_GET['sSearch'] )."%' OR ";
			}
			$sWhere = substr_replace( $sWhere, "", -3 );
			$sWhere .= ')';
		}
		
		
		/* Individual column filtering */
		for ( $i=0 ; $i<count($aColumns) ; $i++ ) {
			if ( isset($_GET['bSearchable_'.$i]) && $_GET['bSearchable_'.$i] == "true" && $_GET['sSearch_'.$i] != '' )  {
				if ( $sWhere == "" ) {
					$sWhere = "WHERE ";
				} else {
					$sWhere .= " AND ";
				}
				$sWhere .= $aColumns[$i]." LIKE '%".addslashes($_GET['sSearch_'.$i])."%' ";
			}
		}
		   
		/* Paging */
		$top = (isset($_GET['iDisplayStart']))?((int)$_GET['iDisplayStart']):0 ;
		$limit = (isset($_GET['iDisplayLength']))?((int)$_GET['iDisplayLength'] ):10;
		$sQuery = "SELECT TOP $limit ".implode(",",$aColumns)."
			FROM $sTable as A  
			$sWhere ".(($sWhere=="")?" WHERE ":" AND ")." $sIndexColumn NOT IN
			(
				SELECT $sIndexColumn FROM
				(
					SELECT TOP $top ".implode(",",$aColumns)."
					FROM $sTable as A
					$sWhere
					$sOrder
				)
				as [virtTable]
			)
			$sOrder";
		 
		$rResult = sqlsrv_query($conn, $sQuery) or die("$sQuery: " . sqlsrv_errors());
	  
		$sQueryCnt = "SELECT * FROM $sTable as A $sWhere";
		$rResultCnt = sqlsrv_query($conn, $sQueryCnt ,$params, $options) or die (" $sQueryCnt: " . sqlsrv_errors());
		$iFilteredTotal = sqlsrv_num_rows( $rResultCnt );
	  
		$sQuery = " SELECT * FROM $sTable as A ";
		$rResultTotal = sqlsrv_query($conn, $sQuery ,$params, $options) or die(sqlsrv_errors());
		$iTotal = sqlsrv_num_rows( $rResultTotal );
		   
		$output = array(
			"sEcho" => $sEcho,
			"iTotalRecords" => $iTotal,
			"iTotalDisplayRecords" => $iFilteredTotal,
			"aaData" => array()
		);
		   
		//while ( $aRow = sqlsrv_fetch_array( $rResult ) ) {
//			$row = array();
//			for ( $i=0 ; $i<count($aColumns) ; $i++ ) {
//				if ( $aColumns[$i] != ' ' ) {
//					$v = $aRow[ $aColumns[$i] ];
//					$v = mb_check_encoding($v, 'UTF-8') ? $v : utf8_encode($v);
//					$row[]=$v;
//				}
//			}

			$aRow = sqlsrv_fetch_array($rResult,  SQLSRV_FETCH_ASSOC);
			
			$row[] = json_encode($aRow);
			
			If (!empty($row)) { $output['aaData'][] = $row; }
		//}    
		echo json_encode( $output );
	}
}
?>