// JavaScript Document

$(document).ready(function(e) {
    
	// ----------------------------------------------------------------------------
	// * call to initialize form
	// ----------------------------------------------------------------------------
	initializeForm();
	
	
	// ----------------------------------------------------------------------------
	// * Saves order to database
	// ----------------------------------------------------------------------------
	$('#btnSave').click(function(){
		var urlOrder = '../purchase/index.php?action=order_save';
		var formOrder = $('#formPurchase').serialize();
		$.post(urlOrder,formOrder,processResponse).fail(function (err) {throw err;});
		
		function processResponse(data)
		{
			$('#message').html(data).hide(5000);		
		}
		
		// --- enable AddOrderItem button
		$('#AddOrderItem').attr('disabled',false);
		
		// --- change save to update
		$('#btnSave').text('Update');
		return false;
	});
	
	
	
	// ----------------------------------------------------------------------------
	// * creates the order item dialog
	// ----------------------------------------------------------------------------
	$( "#formAddOrderItem" ).dialog({ 
			autoOpen: false, 
			resizable: false,
			show: {
				effect: "blind",
				duration: 1000
			},
			hide: {
				effect: "explode",
				duration: 1000
			},
			width:500,
			modal:true,
			buttons: {
				"Save": function() {
					var urlOrder = '../purchase/index.php?action=item_save';
					var formOrder = $('#formOrderItem').serialize();
					$.post(urlOrder,formOrder,processResponse).fail(function (err) {throw err;});
					
					function processResponse(data)
					{
						$('#legItems').text(data);		
					}
					
					return false;
				},
				Cancel: function() {
					
					// --- populate data on grid.
					var urlItem = '../purchase/index.php';
					var urlData = 'op=item&action=list_id';
		
					$.get(urlItem, urlData, processResponse);
					
					function processResponse(data)
					{
						$('#divGrid').html(data);	
					}
					
					$( this ).dialog( "close" );
				}
			}
 	});
	
	
	// ----------------------------------------------------------------------------
	// * click event for AddOrderItem
	// * show add item dialog box
	// ----------------------------------------------------------------------------
	$('#AddOrderItem').click(function(){
		$( "#formAddOrderItem" ).dialog("open");
		
		// --- get the order item code
		var urlItem = '../library/framework/systemNumber.inc.php';
		var urlData = 'mod=order_item';
		
		$.get(urlItem, urlData, processResponse);
		
		function processResponse(data)
		{
			$('#itxtOrderItemCode').val(data).attr('disabled',true);	
		}
		
		// --- set purchase order code
		$('#itxtPurchaseOrderNo').val(window.sessionStorage.OrderCode).attr('disabled',true);
		
		// --- disable form elements
		$('#itxtTaxAmount').attr('disabled', true);	
		
		// --- set legend caption
		$('#legItems').text('Add Order Item');
		
		return false;
	});
	
	
	// ----------------------------------------------------------------------------
	// * blur event for unit cost
	// * calculates the total cost of item
	// ----------------------------------------------------------------------------
	$('#itxtUnitCost').blur(function(){
		var valCost = $(this).val();
		var valQty = $('#itxtQuantity').val();
		
		var valTotal = calculateTotal(valCost, valQty);
		
		$('#itxtTotalPrice').val(valTotal);
	});
	
	
	// ----------------------------------------------------------------------------
	// * click event for quantity
	// * calculates the total cost of item
	// ----------------------------------------------------------------------------
	$('#itxtQuantity').click(function(){
		var valQty = $(this).val();
		var valCost = $('#itxtUnitCost').val();
		
		if (valCost != '')
		{
			var valTotal = calculateTotal(valCost, valQty);
			$('#itxtTotalPrice').val(valTotal);
		}
	});
	
	
	// ----------------------------------------------------------------------------
	// * change event for TAX
	// * calculates the total cost of item
	// ----------------------------------------------------------------------------
	$('#icboTax').change(function(){
		
		var taxRate, taxid = $(this).val();
		var url = '../library/framework/json.php';
		var param = 'op=taxrate&ptr='+taxid;
		
		
		// hack to execute ajax synchronously(use $.ajax and set async:false).
		$.ajax({
			url:url+'?'+param,
			async:false,
			type:"get",
			success:function(data){
				window.sessionStorage.TaxRate = Number(data);
			}
		});
		
		
		//var taxRate = $('#taxRate').val();
		var unitCost = $('#itxtUnitCost').val();
		var quantity = $('#itxtQuantity').val();
		var taxRate = window.sessionStorage.TaxRate;
		 
		
		// -- calculate tax amount and taxed total
		var taxAmount = unitCost * quantity * taxRate;
		var totalCost = Number(calculateTotal(unitCost, quantity)) + taxAmount;
		
		// -- set value of tax amount
		$('#itxtTaxAmount').val(taxAmount);
		
		// --- set value of total price		
		$('#itxtTotalPrice').val(totalCost);
		
		return false;
		
	});
	
	
	// ----------------------------------------------------------------------------
	// * Calculate Total Cost 
	// * calculates the total cost of item
	// * param: Quantity, Cost, Tax 
	// ----------------------------------------------------------------------------
	function calculateTotal(cost, quantity)
	{
		if (isNaN(cost) || isNaN(quantity))
		{
			alert ('Please enter a numeric value');	
		}
		
		var total = cost * quantity;
		return total.toFixed(2);
	}
	
	
	// ----------------------------------------------------------------------------
	// * Check if Receive date is lower than date of order
	// ----------------------------------------------------------------------------
	$('#datReceiveDate').blur(function(){
		var dateReceive = $(this).val();
		var dateOrder = $('#datOrderDate').val();
		
		if (dateReceive < dateOrder)
		{
			alert('Receive date is older than Order date !');
			$(this).focus();
		}
	});
	
	
	// ----------------------------------------------------------------------------
	// * Initialize form
	// ----------------------------------------------------------------------------
	function initializeForm()
	{
		// --- session variable to set order coede
		window.sessionStorage.OrderCode = $('#txtOrderCode').val();
		window.sessionStorage.TaxRate='';
		
		// --- hide summation panel
		$('#divSummation').hide();
		
		// --- reset form variables
		$('#itxtQuantity').val(1);
		$('#taxRate').val(0.0);
		$('#txtFreight').val(0.0);	
	}
});
