<?php

// ---- library references
include_once('../library/framework/awsCore.inc.php');
include_once('facility.inc.php');

class formFacility
{
	function _construct()
	{	
		awsCore::startHtmlPage('Oil Palm Mill');
	}
	
	
	function _destruct()
	{
		awsCore::closeHtmlPage();	
	}
	
	public static function viewFacility($event='new')
	/*
	---------------------------------------------------------------------------
	 viewFacility()
	---------------------------------------------------------------------------
	 Form to add new facility
	---------------------------------------------------------------------------   
    */ 
	{
?>

<div id="formContainer">
<form  method="post" enctype="application/x-www-form-urlencoded">
<?php awsCore::getFormHeader('Health Facility', facility::$sFacilityName, true, false); ?>

<div style="clear:both; padding-bottom:10px"></div>

<div class="panel-group">
  <div class="panel panel-default panel-primary">
    <div class="panel-heading">
        <h4 class="panel-title">Facility Information</h4>
    </div>
    <div>
      <div class="panel-body">
        <div class="row">
            <div class="col-xs-4">
                <img src="<?php if($event=='view'){echo '../images/pic/'.facility::$sImage.'.jpg';} ?>" alt="hospital Photo" width="300px" height="250px">
            </div>
            <div class="col-xs-8">
              <br/>
              <div class="form-group">
                <label for="sFacName" class="col-sm-4 control-label">Facility Name :</label>
                <div class="col-sm-8">
                  <input type="text" class="form-control" id="sFacName" name="sFacName" placeholder="Facility Name" readonly="readonly" value="<?php if($event=='view'){echo facility::$sFacilityName;} ?>">
                </div>
              </div>
              <div class="form-group">
                <label for="sFacType" class="col-sm-4 control-label">Facility Type :</label>
                <div class="col-sm-8">
                  <input type="text" class="form-control" id="sFacType" name="sFacType" placeholder="Facility Type" readonly="readonly" value="<?php if($event=='view'){echo facility::$sFacilityType;} ?>">
                </div>
              </div>
              <div class="form-group">
                <label for="sRegion" class="col-sm-4 control-label">Region :</label>
                <div class="col-sm-8">
                  <input type="text" class="form-control" id="sRegion" name="sRegion" placeholder="Region" readonly="readonly" value="<?php if($event=='view'){echo facility::$sRegion;} ?>">
                </div>
              </div>
              <div class="form-group">
                <label for="sDistrict" class="col-sm-4 control-label">District :</label>
                <div class="col-sm-8">
                  <input type="text" class="form-control" id="sDistrict" name="sDistrict" placeholder="District" readonly="readonly" value="<?php if($event=='view'){echo facility::$sDistrict;} ?>">
                </div>
              </div>
            </div>
        </div>
        </div>
          
      </div>
    </div>
  <div class="panel panel-default panel-primary">
    <div class="panel-heading">
        <h4 class="panel-title">Professional Staff</h4>
    </div>
    <div>
      <div class="panel-body">
        <table class="table table-striped table-bordered">
            <tr>
                <th>Profession</th>
                <th>Full Time</th>
                <th>Part Time</th>
            </tr>
            <tr>
                <td>Medical Doctor</td>
                <td><?php if($event=='view'){echo facility::$sFtMedicalDoctor;}?></td>
                <td><?php if($event=='view'){echo facility::$sPtMedicalDoctor;}?></td>
            </tr>
            <tr>
                <td>Midwife</td>
                <td><?php if($event=='view'){echo facility::$sFtMidwife;}?></td>
                <td><?php if($event=='view'){echo facility::$sPtMidwife;}?></td>
            </tr>
            <tr>
                <td>Medical Assistant</td>
                <td><?php if($event=='view'){echo facility::$sFtMedAssist;}?></td>
                <td><?php if($event=='view'){echo facility::$sPtMedAssist;}?></td>
            </tr>
            <tr>
                <td>Nurse</td>
                <td><?php if($event=='view'){echo facility::$sFtNurse;}?></td>
                <td><?php if($event=='view'){echo facility::$sPtNurse;}?></td>
            </tr>
            <tr>
                <td>Nurse Assistant</td>
                <td><?php if($event=='view'){echo facility::$sFtNurseAssist;}?></td>
                <td><?php if($event=='view'){echo facility::$sPtNurseAssist;}?></td>
            </tr>
            <tr>
                <td>Lab Technician</td>
                <td><?php if($event=='view'){echo facility::$sFtLabTech;}?></td>
                <td><?php if($event=='view'){echo facility::$sPtLabTech;}?></td>
            </tr>
            <tr>
                <td>Pharmacy Assistant</td>
                <td><?php if($event=='view'){echo facility::$sFtPharmAssist;}?></td>
                <td><?php if($event=='view'){echo facility::$sPtPharmAssist;}?></td>
            </tr>
        </table>
      </div>
    </div>
  </div> 
    
  <div class="panel panel-default panel-primary">
    <div class="panel-heading">
        <h4 class="panel-title">Contraceptive Methods</h4>
    </div>
    <div class="panel-body">
        <table class="table table-striped table-bordered">
            <tr>
                <th>Methods</th>
                <th>Yes / No</th>
            </tr>
            <tr>
                <td>Oral Contraceptive</td>
                <td><?php if($event=='view'){echo facility::$sOralContraceptive;}?></td>
            </tr>
            <tr>
                <td>Injectable</td>
                <td><?php if($event=='view'){echo facility::$sInjectable;}?></td>
            </tr>
            <tr>
                <td>Emergency Contraceptive</td>
                <td><?php if($event=='view'){echo facility::$sEmergContraceptive;}?></td>
            </tr>
            <tr>
                <td>Jadelle</td>
                <td><?php if($event=='view'){echo facility::$sJadelle;}?></td>
            </tr>
            <tr>
                <td>Sino Implant</td>
                <td><?php if($event=='view'){echo facility::$sSinoImplant;}?></td>
            </tr>
            <tr>
                <td>Implanon</td>
                <td><?php if($event=='view'){echo facility::$sImplanon;}?></td>
            </tr>
            <tr>
                <td>IUD</td>
                <td><?php if($event=='view'){echo facility::$sIUD;}?></td>
            </tr>
            <tr>
                <td>LNG IUS</td>
                <td><?php if($event=='view'){echo facility::$sLngIus;}?></td>
            </tr>
            <tr>
                <td>BTL</td>
                <td><?php if($event=='view'){echo facility::$sBtl;}?></td>
            </tr>
            <tr>
                <td>Vasectomy</td>
                <td><?php if($event=='view'){echo facility::$sVasectomy;}?></td>
            </tr>
        </table>
      </div>
    </div>
    
  <div class="panel panel-default panel-primary">
    <div class="panel-heading">
        <h4 class="panel-title">Working Days</h4>
    </div>
    <div class="panel-body">
        <table class="table table-striped">
            <tr>
                <th>Days</th>
                <th>Status</th>
            </tr>
            <tr>
                <td>Weekdays</td>
                <td><?php if($event=='view'){echo facility::$sWeekDays;}?></td>
            </tr>
            <tr>
                <td>Saturdays</td>
                <td><?php if($event=='view'){echo facility::$sSaturdays;}?></td>
            </tr>
            <tr>
                <td>Sundays</td>
                <td><?php if($event=='view'){echo facility::$sSundays;}?></td>
            </tr>
        </table>
      </div>
    </div>
  </div>
  </form>
  </div>
<div style="clear:both; margin-top:20px"></div>
<!--end of formContainer-->
<?php
	}
}
?>