<?php

// ---- library references
include_once('../library/framework/awsDB.inc.php');
include_once('../library/framework/awsCore.inc.php');
include_once('../library/framework/awsMap.inc.php');


class incident extends awsDB 
{
	public static $sReportType, $sFullName, $sMobile, $sReportDesc, $sActionTaken;
    public static $sLatitude, $sLongitude, $sAccuracy, $sPhoto, $sIncidentDate;


	function _construct()
	{
		self::$currentUser = 'admin';
		self::$currentDate = date("F j, Y");	
	}
	
	

	public static function Save($action = 'insert')
	/*
  	------------------------------------------------------------------------
	 Save()
  	------------------------------------------------------------------------
	 Validates the form and saves/edits the event.
	 @return mixed TRUE on success, an error message on failure
	------------------------------------------------------------------------
    */
	{
        try
        {
            $currentDate = date("F j, Y");
            
            // ---- retrieve form values
            self::sanitizeInput();
            
            $insert = "INSERT INTO incident(reportType, fullName, mobile, reportDesc, actionTaken, longitude, latitude, incidentDate) VALUES (?,?,?,?,?,?,?,?)";

            $i_param = array('sssssdds', &self::$sReportType, &self::$sFullName, &self::$sMobile, &self::$sReportDesc, &self::$sActionTaken, &self::$sLongitude, &self::$sLatitude, &$currentDate);

            if ($action == 'insert')
            {
                $s = parent::executeQuery($insert, $i_param);	
                
                if(!$s){awsCore::successMessage('Problem Occurred in update. Please contact system administrator!');}
                if($s){awsCore::successMessage('Information has been successfully saved!');}
            }
        }
        catch (Exception $e)
        {
            echo $e->getMessage();	
        }
	}

	
	
	private static function sanitizeInput()
	{
		if (isset($_POST['reportType'])) { self::$sReportType = parent::cleanInput($_POST['reportType']); } 
		if (isset($_POST['fullName'])) { self::$sFullName = parent::cleanInput($_POST['fullName']); } 
		if (isset($_POST['mobile'])) { self::$sMobile = parent::cleanInput($_POST['mobile']); } 
		if (isset($_POST['reportDesc'])) { self::$sReportDesc = parent::cleanInput($_POST['reportDesc']); } 
		if (isset($_POST['actionTaken'])) { self::$sActionTaken = parent::cleanInput($_POST['actionTaken']); } 
		if (isset($_POST['latitude'])) { self::$sLatitude = $_POST['latitude']; }
		if (isset($_POST['longitude'])) { self::$sLongitude = $_POST['longitude']; } 
        if (isset($_POST['accuracy'])) { self::$sAccuracy = parent::cleanInput($_POST['accuracy']); } 
        //if (isset($_POST['photo'])) { self::$sPhoto = parent::cleanInput($_POST['photo']); } 
        if (isset($_POST['incidentDate'])) { self::$sIncidentDate = parent::cleanInput($_POST['incidentDate']); } 
	} // --- end of sanitize input
}
	

?>