<?php
/*
    ---------------------------------------------------------------------------   
     appUtility.php 
    ---------------------------------------------------------------------------
     Utility functions for applications.
    ---------------------------------------------------------------------------
     Copyright 2013, AppGeo Solutions Ltd
     Godwin Badu-Marfo, started 31 January 2013
    --------------------------------------------------------------------------- 
*/


function sanitizeName($txt) 
/*
  ------------------------------------------------------------------------
   sanitizeName()
  ------------------------------------------------------------------------
   Check string for correct coding and filter out forbidden characters
   @param string $txt Text string to be checked.
   @return Returns sanitized string.
  ------------------------------------------------------------------------
*/
{
	if (!mb_check_encoding($txt, 'UTF-8')) 
	{
		die('Character coding   with  errors at input value.');
	}
	
	mb_regex_encoding('UTF-8');
	return mb_ereg_replace("[^-[:alnum:]',  ]", '', $txt);
}


function addTable($content, $rawHTML=array()) 
/*
---------------------------------------------------------------------------
 Adds a table to the page.
---------------------------------------------------------------------------
* @param array $content Two-dimensional array:
* First line contains headings (<th>)
* The following lines contain data (<td>)
* @param array $rawHTML Indicates which columns are added as unfiltered HTML
---------------------------------------------------------------------------   
*/ 
{
	$this->content .= "<table>\n";
	
	// ----	Adds a header
	$this->content .= "<thead><tr>\n";
	foreach ($content[0] as $cell) 
	{
		$this->addElement('th', $cell);
	}
	$this->content .= "</tr></thead>\n";

	// ----	Adds data
	$this->content .= '<tbody>';
	for ($i = 1; $i < count($content); $i++) 
	{
		$this->content .= '<tr>';
	for ($j = 0; $j < count($content[$i]); $j++) 
	{
	if (empty($rawHTML[$j])) 
	{
		$this->addElement('td', $content[$i][$j]);
	} 
	else 
	{
		$this->addHTML('<td>' . $content[$i][$j] . '</td>');
	}
	}
		$this->content .= "</tr>\n";
	}
		$this->content .= "</tbody></table>\n";
}


function bindCombo($control, $sql)
/*
---------------------------------------------------------------------------
 bindCombo()
---------------------------------------------------------------------------
 Populates combo control with datasource.
 @param string Name of combo box control;
 @param string SQL script to execute and returns results.
---------------------------------------------------------------------------   
*/ 
{	
	$conn = new SQLConnection();
	
	if (!isset($sql))
	{
		die('Invalid sql statement parsed!');
	}
	
	$db = $conn->Connect();
	$params = array();
	
	$recordset = sqlsrv_query($db, $sql);
	
	//Populate the combo box.
	echo "<select name = \"".$control."\"  id=\"".$control."\" >";
	
	echo "<option selected=\"selected\">-- select from list --</option>";
	
	while ($row = sqlsrv_fetch_array($recordset))
	{
		echo "<option class=\"optProject\" value =\"{$row[0]}\">{$row[1]}</option>";
	}
	echo "</select>";
}


function getStringOrNull($str)
/*
---------------------------------------------------------------------------
 getStringOrNull()
---------------------------------------------------------------------------
 Returns string or null string
 @param string $str string to be formatted
 return $strRet returns formatted string
---------------------------------------------------------------------------   
*/ 
  {
    $strRet = trim($str);
    if (strlen($strRet) == 0)
    {
      $strRet = "NULL";
    }
    else
    {
      $strRet = "'" . $strRet . "'";
    }
    return $strRet;
  } 
  

?>